#ifndef LANEKEEPING_H
#define LANEKEEPING_H

#include <nodelet/nodelet.h>
#include <ros/ros.h>
#include <logging/MessageOStream.h>

#include "car/laneDataMsg.h"
#include "car/camDataMsg.h"

namespace car
{
class Lanekeeping : public nodelet::Nodelet
{
public:
    Lanekeeping();

    void onInit() override;

private:
    ros::NodeHandle nh;
    MessageOStream messageOStream;
    ros::Publisher laneData;
    ros::Subscriber camData;

    void camDataCallback(const camDataMsg::ConstPtr & inMsg);
};
}
#endif
