#include "mainNode/EgoMotion.h"


namespace car
{

EgoMotion::EgoMotion(ros::NodeHandle nh)
    : messageOStream(nh, "EgoMotion")
      , platoonControllerNotify()
      , cruiseControllerNotify()
{
    environmentData = nh.subscribe("environmentData", 1, &EgoMotion::environmentDataCallback, this);
    stmData = nh.subscribe("stmData", 1, &EgoMotion::stmDataCallback, this);
}

void EgoMotion::environmentDataCallback(const environmentDataMsg::ConstPtr & inMsg)
{
    distance = inMsg->distance;
    relSpeed = inMsg->relativeSpeed;
    computeAndNotify();

    // messageOStream.write("distance", distance).write("relSpeed", relSpeed);
}

void EgoMotion::stmDataCallback(const stmDataMsg::ConstPtr & inMsg)
{
    stmSpeed = inMsg->speed;
    computeAndNotify();

    /* messageOStream.write("stmSpeed", stmSpeed); */
}

void EgoMotion::computeAndNotify()
{
    prvSpeed = (stmSpeed.load() + relSpeed.load());
    cruiseControllerNotify();
}

}
